/*-----------------------------------------------------------------------*\
| Script Name: | ToneDEF.js                                               |
| Version:     | 1.00 (11/01/13)                                          |
| Author:      | ToneDEF (aka Tony Elliott)  http://tonedef.net           |
| Details:     | Required include script for the ToneDEF HTMLTemplate.    |
|              | Works with eXtreme Movie Manager 8 "My Website" feature. |
\*-----------------------------------------------------------------------*/

var	docName = new String(document.location); // Holds the htm document name
 docName = docName.substring(docName.lastIndexOf("/")+1);
 if (docName == "") document.location = "index.htm"; // Redirect for server.com/directory/ urls
var mHome = (docName == "index.htm") || (docName == "index.html"); // True if we're on the home page
var makeWin; // Handle to the make text only window
var appNFO = new Object({vers: "1.00", vdate: "11/01/13"});

/*---------------------*\
| _Filter.htm FUNCTIONS |
\*---------------------*/
/**
	Sets up the Filter pages
	Called by: Filter_*.htm
*/
function doFilterStuff(){
	l = new String(document.location);
	if (mHome){ // We're on the home page index.htm/html
		if (typeof doneTxtOnly != "undefined" && doneTxtOnly){ // Change to text only version if set 
				if ((GetCookie("to") == "true") && (l.charAt(l.length -1).toLocaleLowerCase() == "m") ) document.location = l + "l";
		} else {
			window.onunload = function() { if (typeof makeWin != "undefined") makeWin.close(); }
		}
		if (homePageHeading != ""){ // Set the heading
			document.getElementById("filterTitle").innerHTML = homePageHeading;
		} else {
			document.getElementById("filterTitle").style.display = "none";
		}
		document.getElementById("homeDesc").innerHTML = "&nbsp;<br>" + homeDesc; // Set the home description
		document.getElementById("homeOnly").style.display = "block"; // Show the main home page element
		document.getElementById("thanksBW").style.display = showThanks ? "block" : "none";
		if (new String(document.location).substring(0,4).search(/file/i) == 0){ // Show appropriate local home page elements
			document.getElementById("showHelpButt").style.display = showHelpButton ? "block" : "none";
			if ( (navigator.appName == 'Microsoft Internet Explorer') && (l.charAt(l.length -1).toLocaleLowerCase() == "m") ) {
				document.getElementById("showMakeTxt").style.display = useTextOnly ? "block" : "none";
			}
		}
	}
	// Check if we've made the text only version
	if (typeof doneTxtOnly != "undefined"){
		document.getElementById("txtOnlySwitch").style.display = doneTxtOnly ? "block" : "none";
		document.getElementById("txtOnlyMsg").style.display = showTxtOnlyMsg ? "block" : "none";
		document.getElementById("showMakeTxt").style.display = doneTxtOnly ? "none" : "block";
	}
	document.getElementById("txtOnly").checked = (l.charAt(l.length -1).toLocaleLowerCase() == "l");
	// Turn on the filter buttons
	document.getElementById("TitleChk").style.display = useFilterTitle ? "block" : "none";
	document.getElementById("GenreChk").style.display = useFilterGenre ? "block" : "none";
	document.getElementById("YearChk").style.display = useFilterYear ? "block" : "none";
	document.getElementById("MediaChk").style.display = useFilterMedia ? "block" : "none";
	document.getElementById("RatingChk").style.display = useFilterRating ? "block" : "none";
	document.getElementById("AddedChk").style.display = useFilterAdded ? "block" : "none";
	if (GetCookie("filters") != null ){
		if (useFilterTitle) document.getElementById("Title").style.display = getFCookieVal("t");
		document.getElementById("Title_butt").checked = (getFCookieVal("t") == "none") ? false : true;
		if (useFilterGenre) document.getElementById("Genre").style.display = getFCookieVal("g");
		document.getElementById("Genre_butt").checked = (getFCookieVal("g") == "none") ? false : true;
		if (useFilterYear) document.getElementById("Year").style.display = getFCookieVal("y");
		document.getElementById("Year_butt").checked = (getFCookieVal("y") == "none") ? false : true;
		if (useFilterMedia) document.getElementById("Media").style.display = getFCookieVal("m");
		document.getElementById("Media_butt").checked = (getFCookieVal("m") == "none") ? false : true;
		if (useFilterRating) document.getElementById("Rating").style.display = getFCookieVal("r");
		document.getElementById("Rating_butt").checked = (getFCookieVal("r") == "none") ? false : true;
		if (useFilterAdded) document.getElementById("Added").style.display = getFCookieVal("a");
		document.getElementById("Added_butt").checked = (getFCookieVal("a") == "none") ? false : true;
	} else {
		document.getElementById("Title").style.display = useFilterTitle ? "block" : "none";
		document.getElementById("Genre").style.display = useFilterGenre ? "block" : "none";
		document.getElementById("Year").style.display = useFilterYear ? "block" : "none";
		document.getElementById("Media").style.display = useFilterMedia ? "block" : "none";
		document.getElementById("Rating").style.display = useFilterRating ? "block" : "none";
		document.getElementById("Added").style.display = useFilterAdded ? "block" : "none";
	}
	if ( filterDelim != "" ){ // This swaps the EMM " - " filter delimiter for filterDelimas set in ToneDEF_Config.txt
		document.getElementById("Title").innerHTML = document.getElementById("Title").innerHTML.replace(/ - /g, filterDelim);
		document.getElementById("Genre").innerHTML = document.getElementById("Genre").innerHTML.replace(/ - /g, filterDelim);
		document.getElementById("Year").innerHTML = document.getElementById("Year").innerHTML.replace(/ - /g, filterDelim);
		document.getElementById("Media").innerHTML = document.getElementById("Media").innerHTML.replace(/ - /g, filterDelim);
		document.getElementById("Rating").innerHTML = document.getElementById("Rating").innerHTML.replace(/> - </g, ">" + filterDelim + "<");
		document.getElementById("Added").innerHTML = document.getElementById("Added").innerHTML.replace(/ - /g, filterDelim);
	}
	if (l.charAt(l.length -1).toLocaleLowerCase() == "m"){ // This fixes the filter lists finishing with " - " bug
		document.getElementById("Title").innerHTML = document.getElementById("Title").innerHTML.substring(0, document.getElementById("Title").innerHTML.length - 3);
		document.getElementById("Genre").innerHTML = document.getElementById("Genre").innerHTML.substring(0, document.getElementById("Genre").innerHTML.length - 3);
		document.getElementById("Year").innerHTML = document.getElementById("Year").innerHTML.substring(0, document.getElementById("Year").innerHTML.length - 3);
		document.getElementById("Media").innerHTML = document.getElementById("Media").innerHTML.substring(0, document.getElementById("Media").innerHTML.length - 3);
	}
	document.getElementById("thumbGrid").style.display = (l.charAt(l.length -1).toLocaleLowerCase() == "l") ? "table" : "block";
}


/**
	[f = checkbox reference]
	Show/Hide the various Filter div's. Gets the div from the elements name attribute
	Called by: filter page checkboxes onclick() 
*/
function shF(f){
	elemnt = document.getElementById(f.name.split("_")[0]);
	elemnt.style.display = (elemnt.style.display == "none") ? "block" : "none";
	setFCookie(); // Set the cookie
}

/**
	Set the array of filters in the documents cookie
	Called by: shF()
*/
function setFCookie(){
	exp = new Date( Number(new Date().getTime()+(1000*60*60*24*365)) );
	f = "t=" + ( document.getElementById("Title_butt").checked ? "block" : "none" );
	f = f + ",g=" + ( document.getElementById("Genre_butt").checked ? "block" : "none" );
	f = f + ",y=" + ( document.getElementById("Year_butt").checked ? "block" : "none" );
	f = f + ",m=" + ( document.getElementById("Media_butt").checked ? "block" : "none" );
	f = f + ",r=" + ( document.getElementById("Rating_butt").checked ? "block" : "none" );
	f = f + ",a=" + ( document.getElementById("Added_butt").checked ? "block" : "none" );
	SetCookie("filters", f, exp, "/");
}

/**
	[filtr="t" title | filtr="g" genre | filtr="y" year | filtr="m" media | filtr="r" rating | filtr="a" added]
	Returns the the value of filter from the filters cookie array.
	Called by: doFilterStuff()
*/
function getFCookieVal(filtr){
	tmp = GetCookie("filters").split(",");
	for (i in tmp){
		if (tmp[i].split("=")[0] == filtr) return tmp[i].split("=")[1];
	}
	return "";
}

/**
	Called from the text only checkbox on click
*/
function toggleTxtOnly(){
	exp = new Date( Number(new Date().getTime()+(1000*60*60*24*365)) );
	l = new String(document.location);
	if (l.charAt(l.length -1).toLocaleLowerCase() == "m"){
		SetCookie("to", true, exp, "/");
		document.location = l + "l";
	} else {
		SetCookie("to", false, exp, "/");
		document.location = l.substr(0, l.length -1);
	}
}


/*---------------------*\
| _Detail.htm FUNCTIONS |
\*---------------------*/
// Global variables. !!! DO NOT CHANGE THESE !!!
var movieID, taglines, filesArr, plotArr, tagCurLine = 0, newTab = false;

/**
	Sets up the Detail pages
	Called by: Detail_#.htm onload()
*/
function doDetailStuff(){
	// Do the scroll if multiple tag lines stuff
	taglines = document.getElementById("tagLine").innerHTML; // Grab the taglines
	taglines = taglines.replace(/<pre>/i,"") // Remove the <pre></pre> tag
	taglines = taglines.replace(/<\/pre>/i,"")
	taglines = taglines.split("\n"); // Make the array
	if (taglines.length > 1){
		autoTagline(); // More than one tagline; Start the changer
	} else {
		document.getElementById("tagLine").innerHTML = taglines;
	}
	document.getElementById("tagLine").style.display = "block";
	// Show/Hide the Pevious/Next movie links
	document.getElementById("prevMovie").style.display = showPrevNextMovie ? "block" : "none";
	document.getElementById("nextMovie").style.display = showPrevNextMovie ? "block" : "none";
	// Show/Hide the ratings image
	document.getElementById("ratingBar").style.display = showRatingBar ? "block" : "none";
	// Do the no actor image bug fix stuff
	noActorP = "../images/none-blue.jpg";
	if (ap1 == "") document.getElementById("actorImg1").src = noActorP;
	if (ap2 == "") document.getElementById("actorImg2").src = noActorP;
	if (ap3 == "") document.getElementById("actorImg3").src = noActorP;
	if (ap4 == "") document.getElementById("actorImg4").src = noActorP;
	// Do the Plot/Synopsis Tabs | The next line was added for IE8
	document.getElementById("plotTxt").defaultValue = document.getElementById("plotTxt").defaultValue.replace(/(\r\n|\r|\n)/g, '\n');
	plotArr = document.getElementById("plotTxt").defaultValue.split("Plot Synopsis:\n-------------------\n");
	if (plotArr.length > 1){ // We have a synopsis
		document.getElementById("synopSpan").style.visibility = "visible";
		document.getElementById("plotTxt").value = plotArr[0];
	} else {
		elmnt = document.getElementById("plotButt");
		elmnt.className = "tabButt";
		elmnt.onclick = "";
		elmnt.onmouseover = "";
		elmnt.style.cursor = "auto";
		elmnt.title = "";
	} // Do the files div
	if ( (document.getElementById("filesData").innerHTML != "|||") && showPlayButton){
		if ((new String(document.location).substring(0,4).search(/file/i) == -1) && !showFilesOnline) return;
		filesArr = document.getElementById("filesData").innerHTML.split("|");
		fileCnt = 0;
		for (i in filesArr){ if (filesArr[i] != "") fileCnt = fileCnt + 1; } // Count how many files the movie has
		if (fileCnt == 1){
			pb = "<a href=\"file://" + filesArr[0] + "\" title=\"" + (filesArr[0].substr(filesArr[0].lastIndexOf("\\")+1)) +
					"\" target=\"_blank\"><div id=\"playButt\"><div style=\"margin-left:22px\">Play</div></div></a>";
		} else {
			pb = "<div id=\"playButt\" onmouseover=\"filesPopUpShow(this)\" style=\"cursor: pointer\"><div style=\"margin-left:22px\">Play</div></div>";
		}
		fb = "<div class=\"maintitle_small\">";
		for (i in filesArr){
			if (filesArr[i] != ""){
				fb = fb + "<a href=\"file://" + filesArr[i] + "\" title=\"" + (filesArr[i].substr(filesArr[i].lastIndexOf("\\")+1)) + "\" target=\"_blank\">" +
					"<div id=\"playButt\"><div style=\"margin-left:22px; text-align: left\">File " + String(Number(i)+Number(1)) + "</div></div></a>";
			}
		}
		fb = fb + "</div>";
		document.getElementById("filesbox").innerHTML = fb;
		document.getElementById("filesData").innerHTML = pb;
		document.getElementById("filesLabel").style.display = "block";
		document.getElementById("filesData").style.display = "block";
	}
}

/**
	Does the mouse hover for the tab buttons
	Called by: Mouse over/out on the tab menu elements
*/
function tabOver(over, butt){
	if (over){
		butt.className = (butt.className == "tabButtSel") ? "tabButtHoverSel" : "tabButtHover";	
	} else {
		if (newTab){
			newTab = false;
			return;
		} else {
			butt.className = (butt.className == "tabButtHoverSel") ? "tabButtSel" : "tabButt";
		}
	}
}

/**
	Toggle the tab between Plot & Synopsis
	Called by: Plot & Synopsis tab links
*/
function chgDtab(butt){
	document.getElementById("plotButt").className = "tabButt";
	document.getElementById("synopButt").className = "tabButt";
	butt.className = "tabButtSel";
	document.getElementById("plotTxt").value = (butt.innerHTML.search("Plot") > -1) ? plotArr[0] : plotArr[1].substring(1);
	document.getElementById("plotTxt").scrollTop = 0;
	newTab = true;
}

/**
	Shows the multiple files buttons pop up 
	Called by: playBut & filesbox divs onmouseover()
*/
function filesPopUpShow(obj){
	document.getElementById("filesbox").style.left = (getElementLeft(obj)) +'px';
	document.getElementById("filesbox").style.top = (getElementTop(obj)) + 'px';
	document.getElementById("filesbox").style.visibility = "visible";
	document.getElementById("filesbox").style.display = "block";
}

/**
	Hides the multiple files buttons pop up 
	Called by: filesbox div onmouseout()
*/
function filesPopUpHide(){
	document.getElementById("filesbox").style.display = "none";
}

/**
	Updates the tagLine div. Set the interval in milliseconds on the last line.
	Called by: doDetailStuff()
*/
function autoTagline(){
	if (tagCurLine >= taglines.length) tagCurLine = 0;
	if (taglines[tagCurLine].length == 0){
		tagCurLine = tagCurLine +1;
		autoTagline();
	} else {
		document.getElementById("tagLine").innerHTML = taglines[tagCurLine];
		tagCurLine = tagCurLine +1;
		setTimeout(autoTagline, 5000);
	}
}

/**
	[dir="+" Next | dir="-" Previous]
	Requires the eXmm collection to be numbered consecutivley. Use Tools-Maintainace to be sure.
	Called by: previous/next movie links on the details pages.
*/
function scrollMovie(dir){
	currPage = movieID;
	if (currPage == 1 & dir == "-"){
		currPage = new Number(GetCookie("totalMovies"));
	} else if (currPage == GetCookie("totalMovies") & dir == "+"){
		currPage = 1;
	} else {
		currPage = ( (dir == "+") ? currPage + 1 : currPage - 1 );
	}
	document.location = "Detail_" + currPage + ".htm";
}


function randomMovie(){
	var min = 1;
	var max = new Number(GetCookie("totalMovies"));
	var random = Math.floor(Math.random() * (max - min + 1)) + min;
	document.location = "Detail_" + random  + ".htm";
}


/**
	Required for the actor popup. Repaces single quotation ' characters in the actors name with \'
	Called by: Details pages actor's image onmouseover
*/
function parseASQ(actName){
	return actName.replace(/'/g, "\'");
}

/*---------------------------*\
| ACTOR IMAGE POPUP FUNCTIONS |
\*---------------------------*/
/**
	Show the actor large image in a popup window
*/
function actImgPopUpShow(obj, capt){
	if ( (capt == "") || (obj.src.indexOf("none.jpg") > -1) || (obj.src.indexOf("blank.png") > -1) ) return;
	var imgbox = document.getElementById("imgbox");
	imgbox.style.display = "block";
	imgbox.style.visibility = "visible";
	imgbox.style.height = "auto";
	imgbox.style.font = "bold 11px arial,serif";
	var img = document.createElement("img");
	var b = document.createElement("br")
	img.src = obj.src;
	if(img.addEventListener){
		img.addEventListener("mouseout", actImgPopUpHide, false);
	} else {
		img.attachEvent("onmouseout", actImgPopUpHide);
	}
	imgbox.innerHTML = "";
	imgbox.appendChild(img);
	imgbox.appendChild(b);
	imgbox.style.left = (getElementLeft(obj)-205) +'px';
	imgbox.style.top = (getElementTop(document.getElementById("actorImg1")) - 10) + 'px';
}

/**
	Hide the actor large image popup window
*/
function actImgPopUpHide(){
	document.getElementById("imgbox").style.visibility='hidden';
}

/**
	Called by actImgPopUpShow() | Gets an DOM elements left position on the document in pixels
*/
function getElementLeft(elmnt){
	var x = 0;
	x = elmnt.offsetLeft; //set x to elmnts offsetLeft
	elmnt = elmnt.offsetParent; //set elmnt to its offsetParent
	while(elmnt != null){ // Use while loop to check if elmnt is null if not then add current elmnts offsetLeft to xoffsetTop to y and set elmnt to its offsetParent
		x = parseInt(x) + parseInt(elmnt.offsetLeft);
		elmnt = elmnt.offsetParent;
	}
	return x;
}

/**
	Called by actImgPopUpShow() | Gets an DOM elements top position on the document in pixels
*/
function getElementTop(elmnt){
	var y = 0;    
	y = elmnt.offsetTop; //set x to elmnts offsetLeft
	elmnt = elmnt.offsetParent; //set elmnt to its offsetParent
	while(elmnt != null){
		y = parseInt(y) + parseInt(elmnt.offsetTop);
		elmnt = elmnt.offsetParent;
	}
	return y;
}

/*-----------------------*\
| GLOBAL COOKIE FUNCTIONS |
\*-----------------------*/
function SetCookie(name, value) {
  var argv = SetCookie.arguments;
  var argc = SetCookie.arguments.length;
  var expires = (argc > 2) ? argv[2] : null;
  var path = (argc > 3) ? argv[3] : null;
  var domain = (argc > 4) ? argv[4] : null;
  var secure = (argc > 5) ? argv[5] : false;
	document.cookie = name + "=" + escape (value) +
	((expires == null) ? "" : ("; expires=" + expires.toGMTString())) +
	((path == null) ? "" : ("; path=" + path)) +
	((domain == null) ? "" : ("; domain=" + domain)) +
	((secure == true) ? "; secure" : "");
}

function getCookieVal (offset) {
  var endstr = document.cookie.indexOf (";", offset);
	 if (endstr == -1)
		endstr = document.cookie.length;
		return unescape(document.cookie.substring(offset, endstr));
}

function GetCookie (name) {
  var arg = name + "=";
  var alen = arg.length;
  var clen = document.cookie.length;
  var i = 0;
	while (i < clen) {
		var j = i + alen;
		if (document.cookie.substring(i, j) == arg)
			return getCookieVal (j);
		i = document.cookie.indexOf(" ", i) + 1;
		if (i == 0) break
	}
	return null;
}

function clearCookie() {
	if (!confirm(document.cookie + "\nDelete the above cookies?")) return;
	a = document.cookie.split(";");
	past = new Date();
	past = new Date(past.setYear(past.getFullYear() - 1));
	for (i in a) {
		top.SetCookie(a[i].split("=")[0], "", past, "/");
	}
}